package ru.dbotthepony.mc.otm.client.screen.tech

import com.mojang.blaze3d.vertex.PoseStack
import net.minecraft.network.chat.Component
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen
import ru.dbotthepony.mc.otm.client.screen.panels.slot.AbstractSlotPanel
import ru.dbotthepony.mc.otm.client.screen.panels.slot.BatterySlotPanel
import ru.dbotthepony.mc.otm.client.screen.panels.Dock
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.client.screen.panels.FramePanel
import ru.dbotthepony.mc.otm.client.screen.panels.button.makeDeviceControls
import ru.dbotthepony.mc.otm.client.screen.widget.HorizontalPowerGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.ProgressGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.TallHorizontalPowerGaugePanel
import ru.dbotthepony.mc.otm.menu.tech.EnergyServoMenu

class EnergyServoScreen(menu: EnergyServoMenu, inventory: Inventory, title: Component) : MatteryScreen<EnergyServoMenu>(menu, inventory, title) {
	override fun makeMainFrame(): FramePanel<MatteryScreen<*>> {
		val frame = FramePanel.padded(this,
			width = AbstractSlotPanel.SIZE * 2f + HorizontalPowerGaugePanel.GAUGE_BACKGROUND_TALL.width + 8f + ProgressGaugePanel.GAUGE_BACKGROUND.width * 2f,
			AbstractSlotPanel.SIZE, title)

		BatterySlotPanel(this, frame, menu.dischargeSlot).also {
			it.dock = Dock.LEFT
			it.dockRight = 2f
		}

		object : EditablePanel<EnergyServoScreen>(this@EnergyServoScreen, frame) {
			init {
				dock = Dock.LEFT
				dockRight = 2f
				dockTop = 2f
				width = ProgressGaugePanel.GAUGE_BACKGROUND.width
			}

			override fun innerRender(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
				ProgressGaugePanel.GAUGE_BACKGROUND.render(stack)
			}
		}

		TallHorizontalPowerGaugePanel(this, frame, menu.powerGauge).also {
			it.dock = Dock.LEFT
			it.dockRight = 2f
		}

		object : EditablePanel<EnergyServoScreen>(this@EnergyServoScreen, frame) {
			init {
				dock = Dock.LEFT
				dockRight = 2f
				dockTop = 2f
				width = ProgressGaugePanel.GAUGE_BACKGROUND.width
			}

			override fun innerRender(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
				ProgressGaugePanel.GAUGE_BACKGROUND.render(stack)
			}
		}

		BatterySlotPanel(this, frame, menu.chargeSlot).also {
			it.dock = Dock.LEFT
			it.dockRight
		}

		makeDeviceControls(this, frame, redstone = menu.redstone)

		return frame
	}
}
